#ifndef	__GAPPKIT_GAPPKITDEFINES_H__
#define	__GAPPKIT_GAPPKITDEFINES_H__
/**********************************************************************
  GAppKit/GAppKitDefines.h
**********************************************************************/
/*-
 * Copyright (c) 2004  Goichi Hirakawa  <gooichi AT gyazsquare DOT com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

//
//  Platform specific defs for externs
//

//
// For MACH
//

#if defined(__MACH__)

#ifdef __cplusplus
#define GAPPKIT_EXTERN		extern "C"
#define GAPPKIT_PRIVATE_EXTERN	__private_extern__
#else
#define GAPPKIT_EXTERN		extern
#define GAPPKIT_PRIVATE_EXTERN	__private_extern__
#endif

//
// For Windows
//

#elif defined(WIN32)

#ifndef _BUILDING_GAPPKIT_DLL
#define _GAPPKIT_DLL_GOOP	__declspec(dllimport)
#else
#define _GAPPKIT_DLL_GOOP	__declspec(dllexport)
#endif

#ifdef __cplusplus
#define GAPPKIT_EXTERN		extern "C" _GAPPKIT_DLL_GOOP
#define GAPPKIT_PRIVATE_EXTERN	extern
#else
#define GAPPKIT_EXTERN		_GAPPKIT_DLL_GOOP extern
#define GAPPKIT_PRIVATE_EXTERN	extern
#endif

//
//  For Solaris
//

#elif defined(SOLARIS)

#ifdef __cplusplus
#define GAPPKIT_EXTERN		extern "C"
#define GAPPKIT_PRIVATE_EXTERN	extern "C"
#else
#define GAPPKIT_EXTERN		extern
#define GAPPKIT_PRIVATE_EXTERN	extern
#endif

#endif

#endif	/* __GAPPKIT_GAPPKITDEFINES_H__ */
