#ifndef __GAPPKIT_NSIMAGE_EXTENSIONS_H__
#define __GAPPKIT_NSIMAGE_EXTENSIONS_H__
/**********************************************************************
  GAppKit/NSImage-Extensions.h
**********************************************************************/
/*-
 * Copyright (c) 2004  Goichi Hirakawa  <gooichi AT gyazsquare DOT com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#import <AppKit/NSImage.h>
#import "GAppKitDefines.h"

//-----------------------------------------------------------------------------
//  NSImage (GAppKit) interface
//-----------------------------------------------------------------------------
@interface NSImage (GAppKit)

+ (NSImage*)imageNamed: (NSString*)name inBundle: (NSBundle*)bundle;

- (void)drawFlippedInRect: (NSRect)rect fromRect: (NSRect)fromRect operation: (NSCompositingOperation)op fraction: (float)delta;

@end

#if defined(MACOSX)

#include <CoreFoundation/CFBase.h>

//-----------------------------------------------------------------------------
//  NSImage (GAppKitIcons) interface
//-----------------------------------------------------------------------------
GAPPKIT_EXTERN const NSSize GSmallIconSize;
GAPPKIT_EXTERN const NSSize GLargeIconSize;
GAPPKIT_EXTERN const NSSize GHugeIconSize;
GAPPKIT_EXTERN const NSSize GThumbnailIcon;

@interface NSImage (GAppKitIcons)

+ (void)initializeGAppKitIcons;

- (id)initWithSize: (NSSize)size HFSCreatorCode: (OSType)creator HFSTypeCode: (OSType)type;
- (id)initWithSize: (NSSize)size HFSCreatorCode: (OSType)creator HFSTypeCode: (OSType)type extension: (NSString*)extension MIMEType: (NSString*)MIMEType;

- (id)initFolderIconWithSize: (NSSize)size;
- (id)initOpenFolderIconWithSize: (NSSize)size;
- (id)initTrashIconWithSize: (NSSize)size;
- (id)initFullTrashIconWithSize: (NSSize)size;

@end

//-----------------------------------------------------------------------------
//  NSImage (AppKitBugFix) interface
//-----------------------------------------------------------------------------
@interface NSImage (AppKitBugFix)
+ (void)initializeAppKitBugFix;
@end

//-----------------------------------------------------------------------------
//  NSImage (HTMLDisplayBugFix) interface
//-----------------------------------------------------------------------------
@interface NSImage (HTMLDisplayBugFix)
+ (void)initializeHTMLDisplayBugFix;
@end
#endif /* defined(MACOSX) */

#endif /* __GAPPKIT_NSIMAGE_EXTENSIONS_H__ */
